local playerid = nil;

-- First, create a context --
local context = UI.CreateContext("SampleContext")
 
-- Create a Text frame --

local saia_head = UI.CreateFrame("Texture", "Saia Head", context)
local bubble = UI.CreateFrame("Texture", "Speachbubble", context)
local textframe = UI.CreateFrame("Text", "SampleTextFrame", context)
local window = UI.CreateFrame("RiftWindow", "SampleWindow", context)

--local context2 = UI.CreateContext("NewContext");
---context2:SetSecureMode("restricted")
--local wisbutton = UI.CreateFrame("RiftButton", "Wisdom", context2)
--wisbutton:SetSecureMode("restricted")

bubble:SetLayer(1)
textframe:SetLayer(2)
saia_head:SetTexture("PigeonCrusher", "saia_head.png")
bubble:SetTexture("PigeonCrusher", "bubble.png")


textframe:SetFontColor(1,0,0)

 local fps_count = 1


local posX = 300;
local posY = 300;


local bubble_width = 960
local bubble_height = 162

local head_width = 232
local head_height = 276

local scale = 0.5
local lastTime = Inspect.Time.Frame()

local visibilityTimer = 0;
local visibility = 0;
local visible = true;

local drag = false;
local oldMS = Inspect.Mouse()

local multikillcount = 0;
local multikilltimer = 0;

local killingspreecount = 0;
local killingspreetimer = 0;

local messagebuffer = "";
local messagetimer = 0;

local pvemode = false;

local secondsLeft = 0;



textframe:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+5,posY+5)
bubble:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX,posY)

saia_head:SetHeight(head_height*scale)
saia_head:SetWidth(head_width*scale)
bubble:SetHeight(bubble_height*scale)
bubble:SetWidth(bubble_width*scale)
textframe:SetFontSize(50*scale);
saia_head:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+bubble_width*scale,posY-((head_height-bubble_height)/2)*scale)

window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+bubble_width*scale,posY-((head_height-bubble_height)/2)*scale)
window:SetWidth(head_width*scale)
window:SetHeight(head_width*scale)
-- Give a title to the window
window:SetTitle("who cares")
window:SetAlpha(0)

local function relocate()
window:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+bubble_width*scale,posY-((head_height-bubble_height)/2)*scale)
textframe:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+5,posY)
bubble:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX,posY)
saia_head:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+bubble_width*scale,posY-((head_height-bubble_height)/2)*scale)
end
	
local function resize(amount)
saia_head:SetHeight(head_height*scale)
saia_head:SetWidth(head_width*scale)
bubble:SetHeight(bubble_height*scale)
bubble:SetWidth(bubble_width*scale)
textframe:SetFontSize(50*scale);
saia_head:SetPoint("TOPLEFT", UIParent, "TOPLEFT",posX+bubble_width*scale,posY-((head_height-bubble_height)/2)*scale)
window:SetWidth(head_width*scale)
window:SetHeight(head_width*scale)
diff = (posX+bubble_width*scale)-(posX+bubble_width*(scale-amount))
posX = posX - diff*1.05
posY = posY - 20*amount
relocate()
end	



local function findPlayerID(hEvent,e)
	for id,whois in pairs(e) do
		if whois == "player" then
			playerid = id
		end
	end
end

local function getKillMessage(killer,victim)
	message = killer.." crushed "..victim.."\nlike pigeon"
	return message
end

local function processMultikills()
	multikillcount = multikillcount + 1;
	multikilltimer = 10;
	if multikillcount == 2 then messagebuffer = "weak they are buahahaha "
	elseif multikillcount == 3 then messagebuffer = "DEAAAMNN nerf viod bolt NAW \nBUAHHAAHAHA "
	elseif multikillcount == 4 then messagebuffer = "haha.. dis one know what rolling is \nabout , knive to face is good bam bam"
	elseif multikillcount == 5 then messagebuffer = "Now.. this is ****ing skill or what ????\nbuahaahah....." end
	messagetimer = 2.5
end

local function processKillingSprees()
	killingspreecount = killingspreecount + 1;
	killingspreetimer = 120;
	if killingspreecount == 3 then messagebuffer = "buahahaha ..i like your stile"
	elseif killingspreecount == 5 then messagebuffer = "you da real deal"
	elseif killingspreecount == 8 then messagebuffer = "you kill like the rats ...buahaahah"
	elseif killingspreecount == 12 then messagebuffer = "Liek i told u earlier u da real dea \nbuaahahaha"
	elseif killingspreecount == 50 then messagebuffer =  "50 kill?????? is ok or what\nturn pve mode off nub" end
	messagetimer = 3
end

local function insultToInjury()
	rnd = math.random()
	if rnd < 0.1 then messagebuffer = "..I think the time has come for you \nto learn how to play son. "
	elseif rnd < 0.2 then messagebuffer = "..u learn 2 pvp and stop cry about burst"
	elseif rnd < 0.3 then messagebuffer = "weak skill i sense in this , my time worth more " end
	messagetimer = 4
end

local function kill(hEvent,e)

if e then
		if e.caster and e.target then
			local victim = Inspect.Unit.Detail(e.target)
			if ((victim.player or pvemode)and e.caster==playerid)  then 
				textframe:SetText(getKillMessage("You",e.targetName))
				visibilityTimer = 4;
				processKillingSprees()
				processMultikills()
			end
			
			if (e.target==playerid) then
				textframe:SetText(getKillMessage(e.casterName,"you"))
				visibilityTimer = 4;
				killingspreecount = 0;
				multikillcount = 0;
				insultToInjury();
			end
		
		end
	end
	
end




local function getWisdom()
rnd = math.random()
rnd = rnd*3.00
if rnd < 0.05 then return "I fuk you nub"
elseif rnd < 0.1  then return "I can own u easy nub"
elseif rnd < 0.15 then return "Buahaahahaha"
elseif rnd < 0.2  then return "Im da real deal"
elseif rnd < 0.25 then return "Welcome to die..death awaits you"
elseif rnd < 0.3  then return "BUAHAAA"
elseif rnd < 0.35 then return "i will kill every time i want"
elseif rnd < 0.4  then return "im a body builder and an ex contact sport guy"
elseif rnd < 0.45 then return "like a young girl with a lollipop in a bikini buahaha"
elseif rnd < 0.5  then return "My instincts are strong, my damn nose find weak targets"
elseif rnd < 0.55 then return "u know i own u instant if i want"
elseif rnd < 0.6  then return "Im not God to not die,but Byona my girl is not an opponent for me..."
elseif rnd < 0.65 then return "best pvp class..why u need this...dont \nyou know ?! Me is best pvp class"
elseif rnd < 0.7  then return "stop the cry and go this way ------------>>> PVE server "
elseif rnd < 0.75 then return "Im doomed to OWN "
elseif rnd < 0.8  then return "truth ..u know what truth is ?? Listen this .. dis truth it is,,,"
elseif rnd < 0.85 then return "i know im op BUAHAHAH "
elseif rnd < 0.9  then return "i like the new look ...almost look like me in rl buahahaha "
elseif rnd < 0.95 then return "rogue are op not , i am op "
elseif rnd < 1.00 then return "uweakandsmallPS: i break your forehead "
elseif rnd < 1.05 then return "impossible to kill is the word..if I use nb/rs i cant be killed "
elseif rnd < 1.10 then return "I fight even my brothers in rl for money.. so dont try to not give me what i asking for "
elseif rnd < 1.15 then return "wning people like you in seconds make me feel good , in a hudini style "
elseif rnd < 1.20 then return "2000 kills is weak ,i made 2000 victims in the first 4 minutes of conquest "
elseif rnd < 1.25 then return "i not trust leaderbirds , im in silver and i can own u in 12 sec even if u in diamond "
elseif rnd < 1.30 then return "I am the great emperor of all, and the owner who rule everyone and everything"
elseif rnd < 1.35 then return "I am da real deal,and who die fast and smooth should speak moar , not me "
elseif rnd < 1.40 then return "pray to me and god will help you "
elseif rnd < 1.45 then return "roids are not good , roids are for weak boys ,trust me "
elseif rnd < 1.50 then return "I OWN u ALL "
elseif rnd < 1.55 then return "i can beat u rl like in game"
elseif rnd < 1.60 then return "to be da real deal is not easy but is good "
elseif rnd < 1.65 then return "skill is the path of da owner my friend"
elseif rnd < 1.70 then return "calm down girl stop the cry,trion dont listen to a girlyman like you"
elseif rnd < 1.75 then return "BUahaha ,i eat/drink toxic waste"
elseif rnd < 1.80 then return "Da sky legend is where your mind cant comprehend ,and your senses cant reach"
elseif rnd < 1.85 then return "Time is for some clubbing now,meet some girls ,maybe punish some girlymans buahaah"
elseif rnd < 1.90 then return "One fight ...6k plat ?! is ok or what"
elseif rnd < 1.95 then return "want me to give my messanger ?"
elseif rnd < 2.00 then return "it was my pleasure not more or less."
elseif rnd < 2.05 then return "If this game was with perma death ..i think i would be alone in it buahaha "
elseif rnd < 2.10 then return "next time i kill them 30 times in a raw with savage hate and perfect timing"
elseif rnd < 2.15 then return "Perfect im not ..but almost"
elseif rnd < 2.20 then return "i shoot/beat/kill things that make me sick"
elseif rnd < 2.25 then return "your face is the problem ,but anyway whit out your eyes you may look like a diva"
elseif rnd < 2.30 then return "....I got all da damage from the time i was born and yeah , I was born op "
elseif rnd < 2.35 then return "the drinks ,the womens the songs for me will be what more an emperor need"
elseif rnd < 2.40 then return "your great journey will end only when you will belong to me "
elseif rnd < 2.45 then return "waht kacik -chakick is ? "
elseif rnd < 2.50 then return "i like to curse and make fun of my victims "
elseif rnd < 2.55 then return "to much drama is not so good , players should fight and not talk "
elseif rnd < 2.60 then return "good is to avoid Me because I make u dead fast"
elseif rnd < 2.65 then return "If i where your level i where killed u like 200 times in 100... "
elseif rnd < 2.70 then return "when my hands touch people they go down"
elseif rnd < 2.75 then return "tears can come with pain son , meditate on this,and maybe u will have my respect"
elseif rnd < 2.80 then return "There is a difference like from the moon to earth if we talk about my skill and your non-skill"
elseif rnd < 2.85 then return "if you have a strong mind and soul ....you can shape your own body easy."
elseif rnd < 2.90 then return "Rogues need a buff to be like me ."
elseif rnd < 2.95 then return "pray SAIA ..and you may get lucky ,heaving a harmful and easy way.. going to death realm buahaha"
else return "da perfect team that will own all in pvp is just me " end
end

local function formatText(text)
	if (string.len(text)<40) then return text end
	if (string.len(text)>=40) then
	newtext="";
	pos = 40;
	while (string.sub(text,pos,pos)~=" ") do 
		pos = pos - 1
	end 
		newtext = string.sub(text,0,pos).."\n"..string.sub(text,pos+1)
		return newtext

	end
end

local function sayWisdom()
	
	--Command.Message.Broadcast("guild", nil, "Wisdom", getWisdom());
	--print("wis");
end

local function leftClick(ms)
if (ms.x>posX+bubble_width*scale and ms.x < posX+bubble_width*scale+head_width*scale and ms.y > posY-((head_height-bubble_height)/2)*scale and ms.y < posY-((head_height-bubble_height)/2)*scale + head_height*scale) then
				textframe:SetText(formatText(getWisdom()))
				sayWisdom()
				visibilityTimer = 4;
				end

end



local function rightClick(ms)
if (ms.x>posX+bubble_width*scale and ms.x < posX+bubble_width*scale+head_width*scale and ms.y > posY-((head_height-bubble_height)/2)*scale and ms.y < posY-((head_height-bubble_height)/2)*scale + head_height*scale) then
	drag = true
end
end


local function formatTime(seconds)
	local timetext = "";
	local minutes = math.floor(seconds / 60);
	local seconds = math.floor(seconds - minutes * 60);
	if seconds > 9 then timetext = "Time left: "..minutes.." : "..seconds end
	if seconds < 10 then timetext = "Time left: "..minutes.." : 0"..seconds end
	return timetext;
end

local function middleClick()
	textframe:SetText(formatTime(secondsLeft))
	print(formatTime(secondsLeft));
	visibilityTimer = 1;
end

local function update(hEvent, e)
	local curTime = Inspect.Time.Frame()
	local tpf = curTime-lastTime
	
	if secondsLeft > 0 then
		secondsLeft = secondsLeft - tpf
	end
	
	if secondsLeft < 0 then
		secondsLeft = 0
	end
	
	if visibilityTimer > 0 then 
		visibilityTimer = visibilityTimer - tpf 
		visibility = 1;
		end
		
	if (visibilityTimer <= 0 and visibility > 0) then visibility = visibility - tpf/2 end
	if visibility < 0 then visibility = 0 end
	
	

	if visible then 
	
	bubble:SetAlpha(visibility)
	textframe:SetAlpha(visibility)

	ms = Inspect.Mouse()

	if (oldMS.Left~= ms.Left and ms.Left) then leftClick(ms) end
	if (oldMS.Right~= ms.Right and ms.Right) then rightClick(ms) end
	if (oldMS.Right~= ms.Right and oldMS.Right) then drag = false end
	if (oldMS.Middle~= ms.Middle and ms.Middle and ms.x>posX+bubble_width*scale and ms.x < posX+bubble_width*scale+head_width*scale and ms.y > posY-((head_height-bubble_height)/2)*scale and ms.y < posY-((head_height-bubble_height)/2)*scale + head_height*scale) then middleClick() end

	if drag then
		posX = posX+(ms.x-oldMS.x)
		posY = posY+(ms.y-oldMS.y)
		relocate()
	end

	end
	
	if multikilltimer > 0 then multikilltimer = multikilltimer - tpf end
	if (multikilltimer <= 0 and multikillcount > 0)then multikillcount = 0 end

	
	
	if killingspreetimer > 0 then killingspreetimer = killingspreetimer - tpf end
	if (killingspreetimer <= 0 and killingspreecount > 0)then killingspreecount = 0 end

	
	
	
	
	

	if messagetimer > 0 then messagetimer = messagetimer - tpf end
	if messagetimer < 0 then 
		messagetimer = 0
	end
	if (messagetimer == 0 and messagebuffer ~= "") then 
		textframe:SetText(messagebuffer)
		messagebuffer = ""
		visibilityTimer = 4
	end

	
	
	
	
	oldMS = ms;
	lastTime = curTime
end

local function MouseWheelDown()
	if (drag and scale > 0.3) then 
	scale = scale - 0.05 
	resize(-0.05)
	end
end
local function MouseWheelUp()
	if (drag and scale < 1) then 
	scale = scale + 0.05 
	resize(0.05)
	end
end
local function load(addon)
   if addon == "PigeonCrusher" then
     if saved_posX then
  	posX = saved_posX
     else
  	posX = 300
     end
	 if saved_posY then
  	posY = saved_posY
     else
  	posY = 300
     end
	 if saved_scale then
  	scale = saved_scale
     else
  	scale = 0.5
     end
	 if saved_pve then
  	pvemode = true
     else
  	pvemode = false
     end
	 if saved_seconds then
	 secondsLeft = saved_seconds
	 end
   end
   relocate()
   resize(0)
end
local function save(addon)
   if addon == "PigeonCrusher" then
     if posX then
		saved_posX = posX
     end
	 if posY then
		saved_posY = posY
     end
	 if scale then
		saved_scale = scale
     end
	 if pvemode then
		saved_pve = true
		else saved_pve = false 
	 end
	 if secondsLeft then
		saved_seconds = secondsLeft
	end
   end
end

local function toggle()
	if visible then
		print("Addon hidden");
		bubble:SetAlpha(0)
		textframe:SetAlpha(0)
		saia_head:SetAlpha(0)
		visible = false;
	else
		print("Addon visible");
		saia_head:SetAlpha(1)
		visible = true;
	end

end

local function config(commandline)
	local command = commandline
	if command == "pve" then
		if pvemode then 
			pvemode = false
			print("pve mode off")
		else 
			pvemode = true 
			print("pve mode on")
		end
	
	elseif command == "reset" then
		secondsLeft = 3600
		middleClick()
		print("timer reset");
	
	elseif command == "toggle" then
		toggle()
	
	elseif command == "time" then
		middleClick()

	else print("unknown command, available commands: /pg pve, reset, toggle, time")
	end
	
end



table.insert(Event.Addon.SavedVariables.Save.Begin, {save, "PigeonCrusher", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {load, "PigeonCrusher", "Load variables"})
table.insert(Command.Slash.Register("PigeonCrusher"), {config, "PigeonCrusher", "config"})
table.insert(Command.Slash.Register("pg"), {config, "PigeonCrusher", "config"})
saia_head:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, function(self, h, _x, _y) MouseWheelUp() end, "whell forward")
saia_head:EventAttach(Event.UI.Input.Mouse.Wheel.Back, function(self, h, _x, _y) MouseWheelDown() end, "wheel back")
Command.Event.Attach(Event.System.Update.Begin,update,"Update Loop")
Command.Event.Attach(Event.Combat.Death,kill,"pigeon got crushed")
Command.Event.Attach(Event.Unit.Availability.Full,findPlayerID,"get player id")